#-*- coding: utf-8 -*-
import random
import string
import crypt
from django.contrib.auth.models import User

from django.db import models
from datetime import datetime
from django.utils.encoding import smart_str


class Category(models.Model):
    name = models.CharField(max_length=100)

    def get_absolute_url(self):
        return "/bidon/category/" + self.id

    def __unicode__(self):
        return self.name


class Client(User):
    CHOICES_GENDER = (
        ('M', 'Monsieur'),
        ('Mme', 'Madame'),
        ('Mlle', 'Mademoiselle')
    )

    delivery = models.TextField()
    zipcode = models.IntegerField(max_length=5)
    date = models.DateField(blank=True)
    gender = models.CharField(max_length=1, choices=CHOICES_GENDER)
    categories = models.ManyToManyField(Category, blank=True, null=True)

    def save(self, *args, **kwargs):
        print "save"
        print self.pk
        if self.pk is None:
            print "save"
            self.date = datetime.now()
            self.set_password_crypt(self.password)
        super(Client, self).save(self, *args, **kwargs)

    def __unicode__(self):
        return self.username

    def set_password_crypt(self, raw_password):
        algo = 'crypt'
        saltchars = string.ascii_letters + string.digits + './'
        salt = ''.join(random.choice(saltchars) for i in range(2))
        hsh = crypt.crypt(smart_str(raw_password), salt)
        self.password = '%s$%s$%s' % (algo, salt, hsh)


class Product(models.Model):
    name = models.CharField(max_length=1000, unique=True)
    description = models.TextField()
    price = models.FloatField()
    categories = models.ManyToManyField(Category)
    image = models.TextField()

    def __unicode__(self):
        return self.name


class Order(models.Model):
    CHOICES_ETATS = (
        ('C', 'Cancel'),
        ('B', 'Buy'),
        ('A', 'Archive')
    )

    seed = models.CharField(max_length=100)
    totalPrice = models.FloatField()
    orderContents = models.ManyToManyField(Product, through='OrderContent')
    client = models.ForeignKey(Client)
    state = models.CharField(max_length=1, choices=CHOICES_ETATS)
    createAt = models.DateField()

    def __unicode__(self):
        return self.seed


class OrderContent(models.Model):
    panier = models.ForeignKey(Order)
    quantity = models.IntegerField()
    produit = models.ForeignKey(Product)








